using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Windows.Forms;

namespace DungeonOfDespair
{
    public enum GameStateType
    {
        None,
        Title,
        Loading,
        Play,
        GameOver,
        GameWon
    }

    public interface GameState
    {
        void OnKeyDown(object objectSender, KeyEventArgs keyEventArgs);
        void OnKeyUp(object objectSender, KeyEventArgs keyEventArgs);
        void Update();
        void Draw(Graphics graphics);
        GameStateType NextState { get; }
    }
}
