using System;
using System.Collections.Generic;
using System.Text;

namespace DungeonOfDespair
{
    public class Player
        : Character
    {
        private int m_iHealthWait;
        private bool m_bHasVialRed;
        private bool m_bHasVialGreen;
        private bool m_bHasVialYellow;
        private bool m_bHasVialBlue;

        public Player()
            : base(Properties.Resources.Player)
        {
            Health = 100;
            AutomaticDirection = true;
            m_bHasVialRed = false;
            m_bHasVialGreen = false;
            m_bHasVialYellow = false;
            m_bHasVialBlue = false;
        }

        public override void Update()
        {
            base.Update();
            m_iHealthWait = (m_iHealthWait + 1) % 4;
            if (m_iHealthWait == 0)
                Health = Math.Min(100, Health + 1);
        }

        public bool HasRedVial
        {
            get { return m_bHasVialRed; }
            set { m_bHasVialRed = value; }
        }

        public bool HasGreenVial
        {
            get { return m_bHasVialGreen; }
            set { m_bHasVialGreen = value; }
        }

        public bool HasYellowVial
        {
            get { return m_bHasVialYellow; }
            set { m_bHasVialYellow = value; }
        }

        public bool HasBlueVial
        {
            get { return m_bHasVialBlue; }
            set { m_bHasVialBlue = value; }
        }
    }
}
